function [lambda] = FindApproximateLambda(X, m, k, d_num, FDelta, a0, b0, seed)

% Determines an approximate lambda corresponding to a specified K via the
% helper function CRAFT_AUX

rng(seed);
[row, d] = size(X);
mean_global = mean(X, 1);
sample = randperm(row, 1); 
count = 1;
t = binornd(1, m*ones(1, d));
T = X(sample, :);
X_temp = X;
while count <= k          
      [D,I] = CRAFT_AUX(X_temp, mean_global, T, t, d_num, FDelta);  
      T = [T; X_temp(I, :)];
      X_temp(I, :) = [];
      prob = (count*a0 + sum(t, 1))./((count+eps)*(a0+b0+eps)); 
      t_est = binornd(1, prob); 
      t = [t; t_est];
      count = count +1;
end
lambda = D;