function [p] = purity(z, y, k)

%Computes the purity where cluster assignments are given by z, true labels
%by y, and number of (non-empty) clusters by k
%
%Acknowledgments: I do not know the original author(s) of this snippet that I googled long ago! I added a few
%lines to make it work for our purposes. Thanks to the original (unknown) contributor(s)!

if min(y)==0
   y = y + 1;                %Make clusters numbers start from 1 onwards
end

if min(z)==0
   z = z + 1;                %Make clusters numbers start from 1 onwards
end

errors = 0;
for i=1:1:k
    labels_i = y(z==i);
    if isempty(labels_i)
       continue;
    end
    ux = unique(labels_i);
    if length(ux) == 1
       a = length(labels_i);
       b = labels_i;
    else 
    [a, b] = hist(labels_i, unique(labels_i)); 
    end
    [~, I] = max(a);
    labels_predicted_i = b(I); 
    errors = errors + sum(labels_i ~= labels_predicted_i);
end
p = (size(y) - errors)/size(y);